import dl_model
import os
import random
import time
import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()
from tensorflow.keras.datasets.mnist import load_data

print('MNISTの取得：', flush=True)
mnist = load_data()
train_x, test_x = [[p.reshape(784)/255 for p in m[0]] for m in mnist]
train_z, test_z = [[[0]*d+[1]+[0]*(10-d-1) for d in m[1]] for m in mnist]
print('完了')

x = tf.placeholder(tf.float32, [None, 784])
z = tf.placeholder(tf.float32, [None, 10])
y, keep_prob = dl_model.deepnn(x)

cross_entropy = tf.reduce_mean(
    tf.nn.softmax_cross_entropy_with_logits(logits=y, labels=z))
train_step = tf.train.AdamOptimizer(1e-4).minimize(cross_entropy)

yl = tf.argmax(y, 1)
zl = tf.argmax(z, 1)
ac = tf.reduce_mean(tf.cast(tf.equal(yl, zl), tf.float32))

saver = tf.train.Saver()
session = tf.Session()
session.run(tf.global_variables_initializer())

EPOCH, BATCH = 10, 100
print('学習：', flush=True)
old = time.time()
train = list(zip(train_x, train_z))
for n in range(EPOCH):
    random.shuffle(train)
    train_x, train_z = zip(*train)
    for i in range(0, len(train), BATCH):
        bx, bz = train_x[i:i+BATCH], train_z[i:i+BATCH]
        session.run(train_step, feed_dict={x:bx, z:bz, keep_prob:0.5})
        if i//BATCH%10 == 0:
            progress = (n+(i+BATCH)/len(train))/EPOCH*100
            accuracy = session.run(
                ac, feed_dict={x:bx, z:bz, keep_prob:1.0})*100
            print('進捗率{0:6.2f}%：正解率{1:6.2f}%'.format(
                progress, accuracy))
print(time.time()-old, '秒')

path = os.path.abspath(os.path.dirname(__file__))
saver.save(session, os.path.join(path, 'dl_model'))

print('テスト結果：', flush=True)
count = [[0 for i in range(10)] for j in range(10)]
score = 0
for i in range(0, len(test_x), BATCH):
    bx, bz = test_x[i:i+BATCH], test_z[i:i+BATCH]
    y_label, z_label = session.run(
        (yl, zl), feed_dict={x:bx, z:bz, keep_prob:1.0})
    for j, k in zip(y_label, z_label):
        count[j][k] += 1
        score += 1 if j == k else 0
    if i//BATCH%10 == 0:
        progress = (i+BATCH)/len(test_x)*100
        accuracy = score/(i+BATCH)*100
        print('進捗率{0:6.2f}%：正解率{1:6.2f}%'.format(
            progress, accuracy))

print('正解   ', end='')
for i in range(10):
    print('   [{0}]'.format(i), end='')
print()
for i in range(10):
    print('予測[{0}]'.format(i), end='')
    for j in range(10):
        print('{0:6d}'.format(count[i][j]), end='')
    print()
print('正解率：', score/len(test_x)*100, '%')
